'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.unmap = undefined;

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var unmap = function () {
  var _ref = _asyncToGenerator(_regenerator2.default.mark(function _callee(frames, fileUri, fileContents) {
    var map;
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            if (!(fileContents == null)) {
              _context.next = 4;
              break;
            }

            _context.next = 3;
            return fetch(fileUri).then(function (res) {
              return res.text();
            });

          case 3:
            fileContents = _context.sent;

          case 4:
            _context.next = 6;
            return (0, _stackFrameUtils.getSourceMap)(fileUri, fileContents);

          case 6:
            map = _context.sent;
            return _context.abrupt('return', frames.map(function (frame) {
              var functionName = frame.functionName,
                  lineNumber = frame.lineNumber,
                  columnNumber = frame.columnNumber,
                  _originalLineNumber = frame._originalLineNumber;

              if (_originalLineNumber != null) {
                return frame;
              }
              var fileName = frame.fileName;

              if (fileName) fileName = _path2.default.resolve(fileName);
              var source = map.sources.map(function (s) {
                return s.replace(/[\\]+/g, '/');
              }).filter(function (s) {
                s = _path2.default.resolve(s);
                return s.indexOf(fileName) === s.length - fileName.length;
              }).map(function (s) {
                return s.split(_path2.default.sep);
              }).sort(function (a, b) {
                return Math.sign(a.length - b.length);
              }).map(function (s) {
                return s.join(_path2.default.sep);
              }).map(function (s) {
                return s.split('node_modules');
              }).sort(function (a, b) {
                return Math.sign(a.length - b.length);
              }).map(function (s) {
                return s.join('node_modules');
              });
              if (source.length < 1) return null;

              var _map$generatedPositio = map.generatedPositionFor({
                source: source[0],
                line: lineNumber,
                column: columnNumber
              }),
                  line = _map$generatedPositio.line,
                  column = _map$generatedPositio.column;

              var originalSource = map.sourceContentFor(source[0]);
              return new _stackFrame2.default(functionName, fileUri, line, column || null, (0, _stackFrameUtils.getLinesAround)(line, 3, fileContents), functionName, fileName, lineNumber, columnNumber, (0, _stackFrameUtils.getLinesAround)(lineNumber, 3, originalSource));
            }));

          case 8:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function unmap(_x, _x2, _x3) {
    return _ref.apply(this, arguments);
  };
}();

var _stackFrame = require('stack-frame');

var _stackFrame2 = _interopRequireDefault(_stackFrame);

var _stackFrameUtils = require('stack-frame-utils');

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

exports.unmap = unmap;
exports.default = unmap;